import sys
import argparse
import importlib
import traceback


def main():
    parser = argparse.ArgumentParser(
        prog='custom_exporter',
        description=''
    )
    parser.add_argument('command')
    parser.add_argument('command_args', nargs='*', default=[], type=str)
    args = parser.parse_args()
    module_name = "custom_exporters.%s" % args.command

    try:
        imported_module = importlib.import_module(module_name)
    except Exception:
        traceback.print_exc(file=sys.stdout)
        print("failed to load module %s" % module_name)
        sys.exit(1)

    try:
        cls = imported_module.CustomExporter(args=args.command_args)
    except Exception:
        traceback.print_exc(file=sys.stdout)
        print("failed to load CustomExporter class from module %s" % module_name)
        sys.exit(1)

    try:
        cls.run()
    except Exception as e:
        traceback.print_exc(file=sys.stdout)
        print("generate failed: %s" % e)
        sys.exit(1)

    print(cls.metrics.dump())
